#include<dos.h>
#include<stdlib.h>
#include<alloc.h>
#include<math.h>

#ifndef GRAPH256COLH
#define GRAPH256COLH

class matrix
{
 public:
  void identity();
  void add(matrix& B);
  void mul(matrix& B);
  matrix& operator = (matrix& B);
  float M[4][4];
};

class vector
{
 public:
  float scalmul(vector& B);
  void vectmul(vector& B);
  void trans(matrix& T);
  void rotate(matrix& T);
  void divw();
  void toscreen();
  float length();
  void normalize();
  vector& operator = (vector& B);
  float V[4];
  int operator < (vector&) {return 0;};
};

struct vertex
{
 vector V;
 unsigned char col;
 int u,v;
 int operator < (vertex&) {return 0;};
};

struct triz
{
 int n;
 float z;
 int operator < (triz& T) {return (z>T.z);};
};

template <class T> class list
{
 public:
  void add(T&);
  T& get(int i){return buf[i];};
  void clear();
  int length(){return size;};
  void sort();
  list();
  ~list();
 private:
  T* buf;
  int size;
};

enum GLenum {GL_FRONT,GL_BACK,GL_CULL_FACE,GL_CW,GL_CCW,
     GL_POINTS,
     GL_LINES,GL_LINE_STRIP,GL_LINE_LOOP,
     GL_TRIANGLES,GL_TRIANGLE_STRIP,GL_TRIANGLE_FAN,
     GL_MODELVIEW,GL_PROJECTION,
     GL_WAITRETRACE,GL_DOUBLEBUFFER,
     GL_LIGHTING,GL_NORMALIZE,GL_LIGHT0,GL_SPOT_EXPONENT,GL_POSITION,
     GL_PERSPECTIVE_CORRECTION,GL_PHONG_LIGHTING,GL_PHONG_NORMALIZE,
     GL_DEPTH_TEST,
     GL_TEXTURE_2D,GL_COLOR_INDEX,GL_UNSIGNED_BYTE,
     GL_NEAREST,GL_LINEAR,GL_TEXTURE_MAG_FILTER
     };

class graph256col
{
 public:
  unsigned char color(unsigned char col, unsigned char r, unsigned char g, unsigned char b);
  unsigned char color(int x,int y);
  unsigned char color(unsigned char col) {curcol=col;return col;};
  unsigned char color() {return curcol;};
  void point(int x,int y);
  void line(int x0,int y0,int x1,int y1);
  void triangle(int x0,int y0,int x1,int y1,int x2,int y2);
  void mask(short mask) {Mask=mask;};
  void circle(int x,int y,int r);
  void fill(int x,int y);
  void fill(int x,int y,unsigned char col);
  int Enable(GLenum);
  int Disable(GLenum);
  void swapbuffers();
  void Clear();
  void ClearColor(unsigned char col){clearcol=col;};
  void Begin(GLenum);
  void End();
  void MatrixMode(GLenum mode);
  void LoadMatrixf(float* mtx);
  void LoadIdentity(){curmtx->identity();};
  void MultMatrixf(float* mtx);
  void Rotatef(float ang,float x,float y,float z);
  void Translatef(float x,float y,float z);
  void Scalef(float x,float y,float z);
  void Ortho(float left,float rigth,float bottom,float top,float near_,float far_);
  void Frustum(float left,float right,float bottom,float top,float znear,float zfar);
  void Vertex3f(float x,float y,float z);
  void Vertex2f(float x,float y);
  void Vertex3fv(float* xyz);
  void Normal3f(float x,float y,float z);
  void Normal3fv(float* xyz);
  void Indexb(unsigned char c){curcol=c;};
  void CullFace(GLenum mode) {cullface=mode;};
  void FrontFace(GLenum mode) {frontface=mode;};
  void Lighti(GLenum light,GLenum pname,int param);
  void Lightfv(GLenum light,GLenum pname,float* params);
  void TexImage2D(GLenum target,int level,int components,int width,int height
       ,int border,GLenum format,GLenum type,const void* pixels);
  void TexParameteri(GLenum target,GLenum pname,GLenum param);
  void TexCoord2f(float s,float t);
  graph256col();
  ~graph256col();
 private:
  list<vertex> vrtx;
  list<vector> norm;
  list<vector> ligt;
  list<triz> tang;
  matrix view;
  matrix proj;
  matrix* curmtx;
  vector curnormal;
  unsigned char* texpixels;
  int texcx,texcy;
  GLenum mode;
  GLenum cullface;
  GLenum frontface;
  int tocullface;
  int dblbuf;
  int retr;
  int lighting;
  int phonglight;
  int normalize;
  int phongnormalize;
  int perspective;
  int depthtest;
  int texturing;
  GLenum texfilter;
  vector L;
  int lightexp;
  short Mask;
  unsigned char curcol;
  int curtexu,curtexv;
  unsigned char fillcol;
  unsigned char clearcol;
  unsigned char far *vb;
  unsigned short int old_vid, old_page;
  void scan_vid();
  void set_vid(unsigned short v);
  void transform(vertex&);
  int showtriangle(vector& A,vector& B,vector& C);
  void rotateZ(float ang);
  void rotateY(float ang);
  void rotateX(float ang);
  void triangle(vertex A,vertex B,vertex C);
  void textriangle(vertex A,vertex B,vertex C);
  void textrianglenolight(vertex A,vertex B,vertex C);
  void triangle(vertex A,vertex B,vertex C,vector N1,vector N2,vector N3,vector L1,vector L2,vector L3);
  void textriangle(vertex A,vertex B,vertex C,vector N1,vector N2,vector N3,vector L1,vector L2,vector L3);
  void flattriangle(vertex A,vertex B,vertex C);
  void texflattriangle(vertex A,vertex B,vertex C);
  void light(vertex& V);
  unsigned char texgetpix(float u,float v);
  void putpix(unsigned int x,unsigned int y) {*(vb+y*320+x)=curcol;};
};

extern graph256col gl;

#endif